#include "image.h"
#include <stdlib.h>

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<4) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	res=readBMPfile(av[1],&img);
	if(res<0) {
		printf("摜ǂ߂܂(%d)\n",res);
		return 8;
	}

	writePicture(av[2],img,atoi(av[3]));
	disposeImage(img);
}

int writePicture(char *fname,ImageData *img,int pat)
{
	FILE *fpo;
	int x,y;
	int mx,my,dep;
	Pixel pix;

	mx=img->width;
	my=img->height;
	dep=8;

	if((fpo=fopen((char*)fname,"wb"))==NULL) return FALSE;
	
	outputHeader(fpo,mx,my,dep,pat);
	encode(fpo,img,pat);
	fclose(fpo);

}

int fputLong(long num,FILE *fp)
{
	fputc((num>>24) & 0xff,fp);
	fputc((num>>16) & 0xff,fp);
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int fputShort(long num,FILE *fp)
{
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int outputHeader(FILE *fp,int mx,int my,int dep,int pat)
{
	int i;

	fputc('R',fp);
	fputc('D',fp);
	fputc('P',fp);
	fputc('X',fp);
	fputLong(mx,fp);
	fputLong(my,fp);
	fputLong(dep,fp);
	fputLong(pat,fp);
}


int encode(FILE *fp,ImageData *img,int pat)
{
	int x,y;
	int rx,ry;
	Pixel rgb;
	int mx,my;

	mx=img->width;
	my=img->height;

	for(y=0;y<my;y++) {
		ry=y%2;
		for(x=0;x<mx;x++) {
			rx=x%2;
			if(pat>0 && rx==1 && ry==0) continue;
			if(pat>1 && rx==0 && ry==1) continue;
			if(pat>2 && rx==1 && ry==1) continue;
			getPixel(img,x,y,&rgb);
			fputc(rgb.r,fp);
		}
	}
    return TRUE;
}
