#include "image.h"
#include <stdlib.h>

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	res=readBMPfile(av[1],&img);
	if(res<0) {
		printf("摜ǂ߂܂(%d)\n",res);
		return 8;
	}

	writePicture(av[2],img);
	disposeImage(img);
}

int writePicture(char *fname,ImageData *img)
{
	FILE *fpo;
	int x,y;
	int mx,my,dep;
	Pixel pix;

	mx=img->width;
	my=img->height;
	dep=8;

	if((fpo=fopen((char*)fname,"wb"))==NULL) return FALSE;
	
	outputHeader(fpo,mx,my,dep);
	encode(fpo,img);
	fclose(fpo);

}

int fputLong(long num,FILE *fp)
{
	fputc((num>>24) & 0xff,fp);
	fputc((num>>16) & 0xff,fp);
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int fputShort(long num,FILE *fp)
{
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int outputHeader(FILE *fp,int mx,int my,int dep)
{
	int i;

	fputc('Y',fp);
	fputc('C',fp);
	fputc('R',fp);
	fputc('P',fp);
	fputLong(mx,fp);
	fputLong(my,fp);
	fputLong(dep,fp);
}


int encode(FILE *fp,ImageData *img)
{
	int x,y;
	int yy,cb,cr;
	int R,G,B;
	Pixel rgb;
	int mx,my;

	mx=img->width;
	my=img->height;

	for(y=0;y<my;y++) {
		for(x=0;x<mx;x++) {
			getPixel(img,x,y,&rgb);
			R=rgb.r;
			G=rgb.g;
			B=rgb.b;
			yy=  77*R+150*G+ 29*B;
			yy/=256;
			fputc(yy,fp);
			if(x%2==0) {
				cb= -43*R- 85*G+128*B;
				cb/=256;
				cr= 128*R-107*G- 21*B;
				cr/=256;
				cb+=127;
				cr+=127;
				fputc(cb,fp);
				fputc(cr,fp);
			}
		}
	}
    return TRUE;
}
